# Copyright 2013-2024 Rene Widera, Axel Huebl
#
# This file is part of PIConGPU.
#
# PIConGPU is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# PIConGPU is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with PIConGPU.
# If not, see <http://www.gnu.org/licenses/>.
#

##
## This configuration file is used by PIConGPU's TBG tool to create a
## batch script for PIConGPU runs. For a detailed description of PIConGPU
## configuration files including all available variables, see
##
##                      docs/TBG_macros.cfg
##


#################################
## Section: Required Variables ##
#################################

TBG_wallTime="23:53:00"

TBG_devices_x=1
TBG_devices_y=4
TBG_devices_z=1

TBG_gridSize="192 512 12"
TBG_steps="2500"

TBG_periodic="--periodic 1 1 1"


#################################
## Section: Optional Variables ##
#################################

TBG_pngYZ="--e_png.period 10 --e_png.axis yz --e_png.slicePoint 0.5 --e_png.folder pngElectronsYZ"
TBG_pngYX="--e_png.period 10 --e_png.axis yx --e_png.slicePoint 0.5 --e_png.folder pngElectronsYX"

TBG_ipngYZ="--i_png.period 10 --i_png.axis yz --i_png.slicePoint 0.5 --i_png.folder pngIonsYZ"
TBG_ipngYX="--i_png.period 10 --i_png.axis yx --i_png.slicePoint 0.5 --i_png.folder pngIonsYX"

# [in keV]
TBG_eBin="--e_energyHistogram.period 100 --e_energyHistogram.filter all --e_energyHistogram.binCount 1024 --e_energyHistogram.minEnergy 0 --e_energyHistogram.maxEnergy 5000"
TBG_iBin="--i_energyHistogram.period 100 --i_energyHistogram.filter all --i_energyHistogram.binCount 1024 --i_energyHistogram.minEnergy 0 --i_energyHistogram.maxEnergy 2000000"

TBG_plugins="!TBG_ipngYX                   \
              !TBG_ipngYZ                   \
              !TBG_eBin                     \
              !TBG_iBin                     \
              !TBG_pngYX                    \
              !TBG_pngYZ                    \
              --i_macroParticlesCount.period 100         \
              --e_macroParticlesCount.period 100         \
              --fields_energy.period 10     \
              --e_energy.period 10 --e_energy.filter all \
              --i_energy.period 10 --i_energy.filter all"


#################################
## Section: Program Parameters ##
#################################

TBG_deviceDist="!TBG_devices_x !TBG_devices_y !TBG_devices_z"

TBG_programParams="-d !TBG_deviceDist \
                   -g !TBG_gridSize   \
                   -s !TBG_steps      \
                   !TBG_periodic      \
                   !TBG_plugins       \
                   --versionOnce"

# TOTAL number of devices
TBG_tasks="$(( TBG_devices_x * TBG_devices_y * TBG_devices_z ))"

"$TBG_cfgPath"/submitAction.sh
